*Deck Wr_LIBuf
      Subroutine Wr_LIBuf(IU,Label,NI,LenBuf,N1,N2,N3,N4,N5,ASym,IX)
      Implicit None
C
C     This file provides some useful higher-level routines for Fortran
C     users of qcmatrixio.F.  These are in a separate file because for
C     these operations it is better to have separate Fortran and Python
C     wrappers since variable-length arrays make it cumbersome to
C     wrap the Fortran versions and call them from Python.
C
C     The Fortran routines which are used both here and in the
C     Python interface are in qcmatrixio.F.
C
C     Routines provided here:
C     Call Wr_LIBuf(IU,Label,NI,LenBuf,N1,N2,N3,N4,N5,ASym,X)
C     Call Wr_LRBuf(IU,Label,NI,LenBuf,N1,N2,N3,N4,N5,ASym,X)
C     Call Wr_LCBuf(IU,Label,NI,LenBuf,N1,N2,N3,N4,N5,ASym,X)
C     Write integer/real*8/complex array X unblocked (zeros included)
C     to unit IU given the parameters from the header record.
C
C     Call Wr_LRInd(IU,Label,NR,LenBuf,N1,N2,N3,N4,N5,ASym,X)
C     Write a real array compressed, with indices for non-zero
C     sets of (NR) elements.
C
      Character*(*) Label
      Logical ASym
      Integer IU,NI,LenBuf,N1,N2,N3,N4,N5,IX(*),LenBX,LenArr,NTot
C
      NTot = LenArr(N1,N2,N3,N4,N5)
      LenBX = (LenBuf/NI)*NI
      Call Wr_Labl(IU,Label,NI,0,NTot,LenBX,N1,N2,N3,N4,N5,ASym)
      Call Wr_IBuf(IU,NTot*NI,LenBX,IX)
      Return
      End
*Deck Wr_LRBuf
      Subroutine Wr_LRBuf(IU,Label,NR,LenBuf,N1,N2,N3,N4,N5,ASym,X)
      Implicit None
      Character*(*) Label
      Logical ASym
      Integer IU,NR,LenBuf,N1,N2,N3,N4,N5,LenBX,LenArr,NTot
      Real*8 X(*)
C
      NTot = LenArr(N1,N2,N3,N4,N5)
      LenBX = (LenBuf/NR)*NR
      Call Wr_Labl(IU,Label,0,NR,NTot,LenBX,N1,N2,N3,N4,N5,ASym)
      Call Wr_RBuf(IU,NTot*NR,LenBX,X)
      Return
      End
*Deck Wr_LCBuf
      Subroutine Wr_LCBuf(IU,Label,NR,LenBuf,N1,N2,N3,N4,N5,ASym,X)
      Implicit None
      Character*(*) Label
      Logical ASym
      Integer IU,NR,LenBuf,N1,N2,N3,N4,N5,LenBX,LenArr,NTot
      Complex*16 X(*)
C
      NTot = LenArr(N1,N2,N3,N4,N5)
      LenBX = (LenBuf/(2*NR))*NR
      Call Wr_Labl(IU,Label,0,NR,NTot,LenBX,N1,N2,N3,N4,N5,ASym)
      Call Wr_CBuf(IU,NTot*NR,LenBX,X)
      Return
      End
*Deck Wr_LRInd
      Subroutine Wr_LRInd(IU,Label,NR,LenBuf,N1,N2,N3,N4,N5,ASym,X)
      Implicit None
      Character*(*) Label
      Logical ASym
      Integer IU,NR,LenBuf,N1,N2,N3,N4,N5,LenBX,NNZ,LenArr,NTot,NumNZR
      Real*8 X(NR,*)
C
      NTot = LenArr(N1,N2,N3,N4,N5)
      LenBX = LenBuf/NR
      NNZ = NumNZR(NR,NTot,X)
      Call Wr_Labl(IU,Label,1,NR,NNZ,LenBX,N1,N2,N3,N4,N5,ASym)
      Call Wr_RInd(IU,NR,NTot,NNZ,LenBX,X)
      Return
      End
*Deck Wr_LAO2E
      Subroutine Wr_LAO2E(IU,Label,NR,LenBuf,N,RInt)
      Implicit None
      Character*(*) Label
      Integer IU,NR,LenBuf,N,NTot,LenArr,LenBX,NNZ,NumNZA
      Real*8 RInt(*)
C
      NTot = LenArr(-N,-N,-N,N,1)
      LenBX = LenBuf/(NR+2)
      NNZ = NumNZA(NR,NTot,RInt)
      Call Wr_Labl(IU,Label,4,NR,NNZ,LenBX,-N,-N,-N,N,1,.False.)
      Call Wr_2E(IU,NNZ,NR,N,NTot,LenBX,RInt)
      Return
      End
